rm(list=ls())
library(rgdal)
library(RCurl)
library(XML)
library(rjson)
setwd('xxx') # insert path
punti<-readOGR(dsn=getwd(),layer='casual') # sampling point lkayer


baseURL1<-'https://maps.googleapis.com/maps/api/streetview/metadata?location='
baseURL2<-'&key=your_key' # insert yor Google API key

pano <- data.frame(Num=integer(),lat=double(),lon=double(),pano=character())
for (i in 1:length(punti)){
URL <- paste(baseURL1,coordinates(punti)[i,2],',',coordinates(punti)[i,1],baseURL2,sep='')   #set base URL
raw_data <- getURL(URL, ssl.verifypeer = TRUE)
data <- fromJSON(raw_data)
tmp_df<-data.frame(Num=NA,lat=NA,lon=NA,pano=NA)
if (data$status=='OK') tmp_df<-data.frame(Num=i,lat=data$location$lat,lon=data$location$lng,pano=data$pano_id)
pano<-rbind(pano,tmp_df)
}

sample<-pano2[!duplicated(pano$pano),] # removing points with the same location
sample<-na.omit(sample)
write.table(sample,file='sampleCas.csv',sep=',',row.names=F)
sampleC<-read.table(file='sampleCentr.csv',header=T,sep=',')
sampleR<-read.table(file='sampleCas.csv',header=T,sep=',')

missing<-subset(sampleR, !(pano %in% sampleC$pano))

sample<-sampleC



library(googleway)
library(imager)
key <- 'AIzaSyDAdp-m9GWO9vZmGDauP7hlpB08fbQwGok'
miofov<-60
pitch<-22.5
j<-1

for (j in 1185:dim(sample)[1]) {
nome<-paste('/home/iacopo/Dropbox/PercLab/lavori/UrbanFlickr/SW/',sample$Num[j],'_A.png',sep='')
png(filename=nome)
par(mar=c(0,0,0,0));google_streetview(location = NULL,size = c(400,400),panorama_id = as.character(sample$pano[j]),output = 'plot',heading = 0,fov = miofov,pitch = 0,response_check = FALSE,key = key)
dev.off()
temp<-load.image(nome)
temp<-imsub(temp, x<461, y<461)
temp<-imsub(temp, x>17, y>17)

temp2x<-resize(temp,960,960)
save.image(temp2x,nome)
nome<-paste('/home/iacopo/Dropbox/PercLab/lavori/UrbanFlickr/SW/',sample$Num[j],'_B.png',sep='')
png(filename=nome)
par(mar=c(0,0,0,0));google_streetview(location = NULL,size = c(400,400),panorama_id = as.character(sample$pano[j]),output = 'plot',heading = 60,fov = miofov,pitch = 0,response_check = FALSE,key = key)
dev.off()
temp<-load.image(nome)
temp<-imsub(temp, x<461, y<461)
temp<-imsub(temp, x>17, y>17)

temp2x<-resize(temp,960,960)
save.image(temp2x,nome)
nome<-paste('/home/iacopo/Dropbox/PercLab/lavori/UrbanFlickr/SW/',sample$Num[j],'_C.png',sep='')
png(filename=nome)
par(mar=c(0,0,0,0));google_streetview(location = NULL,size = c(400,400),panorama_id = as.character(sample$pano[j]),output = 'plot',heading = 120,fov = miofov,pitch = 0,response_check = FALSE,key = key)
dev.off()
temp<-load.image(nome)
temp<-imsub(temp, x<461, y<461)
temp<-imsub(temp, x>17, y>17)

temp2x<-resize(temp,960,960)
save.image(temp2x,nome)
nome<-paste('/home/iacopo/Dropbox/PercLab/lavori/UrbanFlickr/SW/',sample$Num[j],'_D.png',sep='')
png(filename=nome)
par(mar=c(0,0,0,0));google_streetview(location = NULL,size = c(400,400),panorama_id = as.character(sample$pano[j]),output = 'plot',heading = 180,fov = miofov,pitch = 0,response_check = FALSE,key = key)
dev.off()
temp<-load.image(nome)
temp<-imsub(temp, x<461, y<461)
temp<-imsub(temp, x>17, y>17)

temp2x<-resize(temp,960,960)
save.image(temp2x,nome)
nome<-paste('/home/iacopo/Dropbox/PercLab/lavori/UrbanFlickr/SW/',sample$Num[j],'_E.png',sep='')
png(filename=nome)
par(mar=c(0,0,0,0));google_streetview(location = NULL,size = c(400,400),panorama_id = as.character(sample$pano[j]),output = 'plot',heading = 240,fov = miofov,pitch = 0,response_check = FALSE,key = key)
dev.off()
temp<-load.image(nome)
temp<-imsub(temp, x<461, y<461)
temp<-imsub(temp, x>17, y>17)

temp2x<-resize(temp,960,960)
save.image(temp2x,nome)
nome<-paste('/home/iacopo/Dropbox/PercLab/lavori/UrbanFlickr/SW/',sample$Num[j],'_F.png',sep='')
png(filename=nome)
par(mar=c(0,0,0,0));google_streetview(location = NULL,size = c(400,400),panorama_id = as.character(sample$pano[j]),output = 'plot',heading = 300,fov = miofov,pitch = 0,response_check = FALSE,key = key)
dev.off()
temp<-load.image(nome)
temp<-imsub(temp, x<461, y<461)
temp<-imsub(temp, x>17, y>17)

temp2x<-resize(temp,960,960)
save.image(temp2x,nome)
}





